#!/bin/bash

PRIVATE_DB="${1}"
PRIVATE_DB_DEFAULT="/tmp/safesquid/private_categories_db"
CAT_FOLDER="/tmp/safesquid/safesquidPvtCategoryList"
SORT_FILE="${CAT_FOLDER}/sort_file"

GET_PRIVATE_DB () {

    [ "x${PRIVATE_DB}" == "x" ] && echo "Not Defined: PRIVATE_DB, using default value" && PRIVATE_DB="${PRIVATE_DB_DEFAULT}" && echo "SAFESQUID CATEGORY DB FILE IN USE: ${PRIVATE_DB}"

}

FILE_CHECK () {
	
    [ -d "${CAT_FOLDER}" ] && find "${CAT_FOLDER}"  -maxdepth 0 ! -empty -exec echo "Folder Not empty: {}" \; -exec echo "Refresh: {} " \; -exec rm -rf {} \; -exec mkdir -p {} \;
    [ ! -d "${CAT_FOLDER}" ] && echo "Folder Not Found: ${CAT_FOLDER}" && echo "Creating Folder: ${CAT_FOLDER}" && mkdir -p "${CAT_FOLDER}";

}

GET_WEBSITE () {
    
    echo "Sorting: Started!"
    while read -r website
    do
        GET_CAT=$( grep -wF "${website}" ${PRIVATE_DB} | awk -F"category=" '{print $2}' | awk -F'"' '{print $2}' )
        if grep -q  "," <<< "${GET_CAT}" 
            then 
                while read -r CATG
                do 
                    echo "${website}" >> "${CAT_FOLDER}/${CATG}"
                    if [ -z "${CATG}" ]
                    then 
                        GET_CAT=$( grep -F "\"${website}\"" ${PRIVATE_DB} | awk -F"category=" '{print $2}' | awk -F'"' '{print $2}' )
                        echo "${website}" >> "${CAT_FOLDER}/${GET_CAT}"
                    fi
                done < <( sed s/','/'\n'/g <<< "${GET_CAT}" )
        elif [ -z "${GET_CAT}" ]
            then 
                GET_CAT=$( grep -F "\"${website}\"" ${PRIVATE_DB} | awk -F"category=" '{print $2}' | awk -F'"' '{print $2}' )
                echo "${website}" >> "${CAT_FOLDER}/${GET_CAT}"            
        else
            echo "${website}" >> "${CAT_FOLDER}/${GET_CAT}"
        fi
    done < <( awk -F"<site website=" '{print$2}' ${PRIVATE_DB} | awk -F'"' '{print $2}' | sed  '/^$/d' )

}

GET_CLEAN_FILE () {

    while read -r PVT_CAT; do
        cat "${CAT_FOLDER}/${PVT_CAT}" | sort | uniq > "${SORT_FILE}"
        sed -i '/^$/d' "${SORT_FILE}"
        mv "${SORT_FILE}" "${CAT_FOLDER}/${PVT_CAT}"
    done < <(awk '{for (i=9; i<NF; i++) printf $i " "; if (NF >= 4) print $NF; }' <( ls -lrt "${CAT_FOLDER}"))
	echo "Sorting: Completed!"
	echo "Get Results: ${CAT_FOLDER}"

}

MAIN () {

    GET_PRIVATE_DB
    FILE_CHECK
    GET_WEBSITE
    GET_CLEAN_FILE
}

MAIN 